unit UMainFrm;
 {Requires the Propeller Tool to be installed because we are going to use
   propellent.dll which gets installed with it.
  This is a test app to try out concepts}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UPropellentdll, StdCtrls;

type
  TForm1 = class(TForm)
    btnGetInfo: TButton;
    Memo1: TMemo;
    btnShowComDlg: TButton;
    btnGetVersion: TButton;
    procedure btnGetInfoClick(Sender: TObject);
    procedure btnShowComDlgClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnGetVersionClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnGetInfoClick(Sender: TObject);
var
 Version : LongWord;
 MyString : Array[0..MAX_PATH + 1] of Char;
 PMyPath : PChar;

begin

  try
    // Init propellent.dll, Pass False for no changes
    InitPropellent(Form1.Handle,False,nil);
    
    {Try some of the funtions in propellent.dll
     In each case we execute a dll function which returns a pointer
     to a null terminated string. We then copy that to our string
     array MyString and then add it the Memo .}
    PMyPath := GetLibraryPath;
    StrPLCopy(MyString,PMyPath,MAX_PATH + 1);
    Memo1.Lines.Add('Library Path is : ' + MyString);

    PMyPath := GetSerialSearchRules;
    StrPLCopy(MyString,PMyPath,MAX_PATH + 1);
    Memo1.Lines.Add('Serial Search Rules: '+ MyString);

    PMyPath := GetPorts;
    StrPLCopy(MyString,PMyPath,MAX_PATH + 1); 
    Memo1.Lines.Add('Found Com Ports are: ' + MyString);

    {GetLibraryVersion returns an LongWord}
    Version := GetLibraryVersion;
    Memo1.Lines.Add('Dll Version is :' + '$' + IntToHex(Version,1));

  finally
    {This gets executed even if something crashes in the try part}
    FinalizePropellent;
  end;

end;

procedure TForm1.btnGetVersionClick(Sender: TObject);
var
 zVer : Array[0..80] of Char;
 PzVer : PChar;

begin
  try
   InitPropellent(Form1.Handle,False,nil);
   PzVer := GetPropellerVersion;
   StrPLCopy(zVer,PzVer,79);
   Memo1.Lines.Add('Propeller Version: ' + zVer);
  finally
   FinalizePropellent;
  end;

end;

procedure TForm1.btnShowComDlgClick(Sender: TObject);
begin
  try
   InitPropellent(Form1.Handle,False,nil);
   ShowEditPorts;

  finally
   FinalizePropellent;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 ReportMemoryLeaksOnShutdown := True;
end;

end.
