unit UPropellentdll;
{
Interface to the propeller tool dll supplied by Parallax
}

interface
{Declare some of the funtions and procedures in the propellent.dll}

Procedure InitPropellent(WinHandle: LongWord; StorePref: Boolean;
                          RegPath : PChar); cdecl;
Function GetLibraryVersion : LongWord ; cdecl;
Procedure FinalizePropellent; cdecl;
Function GetLibraryPath: PChar; cdecl;
Function GetSerialSearchRules: PChar; cdecl;
Procedure ShowEditPorts; cdecl;
Function GetPorts: PChar; cdecl;

{The next Function searches for a propeller and if found returns a null
 string containing the com port and version.
 Version is not as interesting as com port as I now know what com port the
 propeller is on and can use that info in my PC app for which com port to open}
Function GetPropellerVersion: PChar; cdecl;

//Declare the Function used to download code
// Use this to download a binay code image from our Delphi User Interface
// Use the Propeller Tool to create a binary image of your spin program
// "SpinCode.binary" and use the next function to download it to the prop
// from your PC application. Set DownLoadCMD to 1 to download to RAM and Run
Procedure DownloadToPropeller(FName : PChar; DownLoadCMD : Byte); cdecl;



implementation
{ In the implementation section instead of writing code for the functions
 declare tham as external in propellent.dll}

const
 propellent = 'propellent.dll';

 Procedure InitPropellent; cdecl;  external propellent;
 Function GetLibraryVersion; cdecl;  external propellent;
 Procedure FinalizePropellent; cdecl;  external propellent;
 Function GetLibraryPath; cdecl;  external propellent;
 Function GetSerialSearchRules; cdecl;  external propellent;
 Procedure ShowEditPorts; cdecl;  external propellent;
 Function GetPorts; cdecl;  external propellent;
 Function GetPropellerVersion; cdecl;  external propellent;
 Procedure DownloadToPropeller; cdecl;   external propellent;


 end.
